C  General integrator for ODE's using the modified Euler method
C  File:  meuler.fcm		Header:  meuler.h

C  Perform S steps with interval h from t0, initial state X, for
C  the equation DX = F(X, t, N), X being a vector of N entries.
C  Leaves state for t0 + S*h in X at end of calculation.

      INTERFACE
      subroutine mEuler(X, F, t0, h, S, N)           ! Single precision
      integer S, N
      real, array(N) :: X
CMF$  LAYOUT X()
      real t0, h
      INTERFACE
	function F(X, t, N)
	integer N
	real, array(N) :: F, X
	real t
CMF$	LAYOUT X()
      END INTERFACE
      END INTERFACE

      INTERFACE
      subroutine mEulerd(X, F, t0, h, S, N)          ! Double precision
      integer S, N
      double precision, array(N) :: X
CMF$  LAYOUT X()
      double precision t0, h
      INTERFACE
	function F(X, t, N)
	integer N
	double precision, array(N) :: F, X
	double precision t
CMF$	LAYOUT X()
      END INTERFACE
      END INTERFACE

